/**********************************************************************
 *<
	FILE: maxPluginTest.cpp

	DESCRIPTION:	Appwizard generated plugin

	CREATED BY: 

	HISTORY: 

 *>	Copyright (c) 2003, All Rights Reserved.
 **********************************************************************/

#include "maxPluginTest.h"
#include <decomp.h>

#define maxPluginTest_CLASS_ID	Class_ID(0x9adaf698, 0xcbe0889e)

class maxPluginTest : public SceneExport {
	public:
		
		static HWND hParams;
		
		int				ExtCount();					// Number of extensions supported
		const TCHAR *	Ext(int n);					// Extension #n (i.e. "3DS")
		const TCHAR *	LongDesc();					// Long ASCII description (i.e. "Autodesk 3D Studio File")
		const TCHAR *	ShortDesc();				// Short ASCII description (i.e. "3D Studio")
		const TCHAR *	AuthorName();				// ASCII Author name
		const TCHAR *	CopyrightMessage();			// ASCII Copyright message
		const TCHAR *	OtherMessage1();			// Other message #1
		const TCHAR *	OtherMessage2();			// Other message #2
		unsigned int	Version();					// Version number * 100 (i.e. v3.01 = 301)
		void			ShowAbout(HWND hWnd);		// Show DLL's "About..." box

		BOOL SupportsOptions(int ext, DWORD options);
		int				DoExport(const TCHAR *name,ExpInterface *ei,Interface *i, BOOL suppressPrompts=FALSE, DWORD options=0);

		//Constructor/Destructor
		maxPluginTest();
		~maxPluginTest();		

	private:
		FILE* m_pFile;
	private:
		void Export(INode* pNode, int iTreeDepth = 0);
		void ExportObject(INode* pNode, int iTreeDepth);
		void ExportObject(TriObject* pTriObj, int iTreeDepth);
		void ExportTRS(INode* pNode, int iTreeDepth);
		bool BeginWriting(const char* pPath);
		void EndWriting();
		void Write(int indent, const char* pMsg, ...);
		void Write(int indent, const Matrix3& tmVal);

};



class maxPluginTestClassDesc : public ClassDesc2 {
	public:
	int 			IsPublic() { return TRUE; }
	void *			Create(BOOL loading = FALSE) { return new maxPluginTest(); }
	const TCHAR *	ClassName() { return GetString(IDS_CLASS_NAME); }
	SClass_ID		SuperClassID() { return SCENE_EXPORT_CLASS_ID; }
	Class_ID		ClassID() { return maxPluginTest_CLASS_ID; }
	const TCHAR* 	Category() { return GetString(IDS_CATEGORY); }

	const TCHAR*	InternalName() { return _T("maxPluginTest"); }	// returns fixed parsable name (scripter-visible name)
	HINSTANCE		HInstance() { return hInstance; }					// returns owning module handle
	

};

static maxPluginTestClassDesc maxPluginTestDesc;
ClassDesc2* GetmaxPluginTestDesc() { return &maxPluginTestDesc; }





INT_PTR CALLBACK maxPluginTestOptionsDlgProc(HWND hWnd,UINT message,WPARAM wParam,LPARAM lParam) {
	static maxPluginTest *imp = NULL;

	switch(message) {
		case WM_INITDIALOG:
			imp = (maxPluginTest *)lParam;
			CenterWindow(hWnd,GetParent(hWnd));
			return TRUE;

		case WM_CLOSE:
			EndDialog(hWnd, 0);
			return 1;
	}
	return 0;
}


//--- maxPluginTest -------------------------------------------------------
maxPluginTest::maxPluginTest()
{
	m_pFile = NULL; 
}

maxPluginTest::~maxPluginTest() 
{
	DbgAssert(m_pFile == NULL);
}

int maxPluginTest::ExtCount()
{
	//TODO: Returns the number of file name extensions supported by the plug-in.
	return 1;
}

const TCHAR *maxPluginTest::Ext(int n)
{		
	//TODO: Return the 'i-th' file name extension (i.e. "3DS").
	return _T("txt");
}

const TCHAR *maxPluginTest::LongDesc()
{
	//TODO: Return long ASCII description (i.e. "Targa 2.0 Image File")
	return _T("MaxPlugin Test");
}
	
const TCHAR *maxPluginTest::ShortDesc() 
{			
	//TODO: Return short ASCII description (i.e. "Targa")
	return _T("My ASCII");
}

const TCHAR *maxPluginTest::AuthorName()
{			
	//TODO: Return ASCII Author name
	return _T("dolphin");
}

const TCHAR *maxPluginTest::CopyrightMessage() 
{	
	// Return ASCII Copyright message
	return _T("Free");
}

const TCHAR *maxPluginTest::OtherMessage1() 
{		
	//TODO: Return Other message #1 if any
	return _T("");
}

const TCHAR *maxPluginTest::OtherMessage2() 
{		
	//TODO: Return other message #2 in any
	return _T("");
}

unsigned int maxPluginTest::Version()
{				
	//TODO: Return Version number * 100 (i.e. v3.01 = 301)
	return 100;
}

void maxPluginTest::ShowAbout(HWND hWnd)
{			
	// Optional
}

BOOL maxPluginTest::SupportsOptions(int ext, DWORD options)
{
	// TODO Decide which options to support.  Simply return
	// true for each option supported by each Extension 
	// the exporter supports.

	return TRUE;
}


int	maxPluginTest::DoExport(const TCHAR *name,ExpInterface *ei,Interface *i, BOOL suppressPrompts, DWORD options)
{
	//TODO: Implement the actual file Export here and 
	//		return TRUE If the file is exported properly
/*
	if(!suppressPrompts)
		DialogBoxParam(hInstance, 
				MAKEINTRESOURCE(IDD_PANEL), 
				GetActiveWindow(), 
				maxPluginTestOptionsDlgProc, (LPARAM)this);
*/
	if (BeginWriting(name))
	{
		// Interface* can also be accessed by GetCOREInterface()
		INode* pRootNode = i->GetRootNode();

		//Export tree.
		Export(pRootNode);

		EndWriting();

		return TRUE; // We have successfully exported to our file!
	}

	// If we are here, something in the export failed.
	return FALSE;
}


void maxPluginTest::Export(INode* pNode, int iTreeDepth /* = 0 */)
{
	// First step to export: What are we exporting?
	// Here we are going to export the basic scene tree,
	// identifying each node by name.

	MCHAR* pNodeName = pNode->GetName();
	int nChildren = pNode->NumberOfChildren();

	// Write out this node as [NodeName] : XX Children
	Write(iTreeDepth, "[%s] : %i children", pNodeName, nChildren);

    // Write out this nodes local transform
	ExportTRS(pNode, iTreeDepth);

	// Write out this nodes object properties
	ExportObject(pNode, iTreeDepth);

	// Recursively call the children
	iTreeDepth++;
	for (int i = 0; i < nChildren; i++)
	{
		Export(pNode->GetChildNode(i), iTreeDepth);
	}
}

void maxPluginTest::ExportObject(INode* pNode, int iTreeDepth)
{
	// Get a pointer to this nodes object reference
	Object* pObject = pNode->GetObjectRef();

	// the root node for example, doesnt have an object
	if (pObject != NULL)
	{
		SClass_ID lSuperID = pObject->SuperClassID();
		Class_ID lClassID = pObject->ClassID();

		// Write out our class types
		// See also SDK documentation for "list of Super Class IDs"
		Write(iTreeDepth, "Obj SuperclassID : %X", lSuperID);
		Write(iTreeDepth, "Obj ClassID : (%X, %X)", lClassID.PartA(), lClassID.PartB());

		// Is it possible that we can convert this object to
		// something we understand?  Here we try converting
		// to a TriObject, using its Class_ID
		if (pObject->CanConvertToType(triObjectClassID))
		{
			TriObject* pTriObject = (TriObject*)pObject->ConvertToType(0, triObjectClassID);
			if (pTriObject != NULL)
			{
				// Write out the mesh indented
				ExportObject(pTriObject, iTreeDepth + 1);

				// Note that if the TriObject pointer does not
				// point to the the original object, it is a new
				// instance that we are now responsible for
				if (pTriObject != pObject)
				{
					// Never call delete directly on any max class
					pTriObject->DeleteMe();
				}
			}
		}
	}
}

void maxPluginTest::ExportObject(TriObject* pTriObj, int iTreeDepth)
{
	// See the SDK Documentation for "PG: Working With Meshes"

	// Get the data container
	Mesh& lMesh = pTriObj->GetMesh();

	// How many vertices?
	int nVerts = lMesh.getNumVerts();
	Write(iTreeDepth, "Number of Vertices: %i", nVerts);

	// Write the vertices positions
	for (int i = 0; i < nVerts; i++)
	{
		Point3& vtx = lMesh.getVert(i);
		Write(iTreeDepth, "Vertex[%02i] : (%f,\t%f,\t%f)", i, vtx.x, vtx.y, vtx.z);
	}

	// Write out our triangle indices
	int nTris = lMesh.getNumFaces();
	Write(iTreeDepth, "Number of Triangles : %i", nTris);

	for (int i = 0; i < nTris; i++)
	{
		// Mesh has a public property, lFace,
		// that we use to access face data
		Face& lFace = lMesh.faces[i];
		// Retrieves a pointer to the index array
		DWORD* pIndices = lFace.getAllVerts();

		Write(iTreeDepth, "Face[%02i], Vertex IDs : (%u, %u, %u)",
					i, pIndices[0], pIndices[1], pIndices[2]);
	}
}


void maxPluginTest::ExportTRS(INode* pNode, int iTreeDepth)
{
	// Export the initial state, that is, at time 0
	Matrix3 tmWorld = pNode->GetNodeTM(0);
	Matrix3 tmParent = pNode->GetParentTM(0);
	Matrix3 tmLocal = tmWorld * Inverse(tmParent);

	Write(iTreeDepth, tmLocal);
}


bool maxPluginTest::BeginWriting(const char *pPath)
{
	// Check we are not currently writing
	DbgAssert(m_pFile == NULL);

	errno_t lErr = fopen_s(&m_pFile, pPath, "w");
	return ( lErr == 0 );
}

void maxPluginTest::EndWriting()
{
	DbgAssert(m_pFile != NULL);

	fclose(m_pFile);
	m_pFile = NULL;
}

void maxPluginTest::Write(int indent, const char* pMsg, ...)
{
	DbgAssert(m_pFile != NULL);

	// first, write in the indent
	for (int i = 0; i < indent; i++) fprintf_s(m_pFile, "\t");

	// Write the message, passing in our variable
	// parameters to a function that wraps printf
	va_list vargs;
	va_start(vargs, pMsg);
	vfprintf_s(m_pFile, pMsg, vargs);
	va_end(vargs);

	// Finish the line
	fprintf_s(m_pFile, "\n");
}


void maxPluginTest::Write(int indent, const Matrix3 &tmVal)
{
	AffineParts apVal;
	float dRotEuler[3];

	decomp_affine(tmVal, &apVal);

	// Convert the rotation quaternion in apVal to rotation euler
	apVal.q.GetEuler(&dRotEuler[0], &dRotEuler[1], &dRotEuler[2]);

	// Write out the position
	Write(indent, "TRS: T (%f, %f, %f)", apVal.t.x, apVal.t.y, apVal.t.z);
	// The Euler rotation
	Write(indent, "     R (%f, %f, %f)", dRotEuler[0], dRotEuler[1], dRotEuler[2]);
	// And finally the scale
	Write(indent, "     S (%f, %f, %f)", apVal.k.x, apVal.k.y, apVal.k.z);
}